package space.kklochko.simple_jbdd.tests.factories.validators;

import java.lang.reflect.Method;
import java.util.ArrayList;
import java.util.Map;
import java.util.stream.Collectors;

abstract public class MethodValidator extends Validator{
    protected boolean isInvalid;

    protected ArrayList<Method> invalidMethods;

    protected String getMethodListAsString() {
        return invalidMethods.stream()
                .map(m -> m.getName())
                .collect(Collectors.joining(", "));
    }

    abstract protected boolean isMethodInvalid(Method method);

    @Override
    public boolean validate(Map<String, ArrayList<Method>> methods) {
        isInvalid = false;
        invalidMethods = new ArrayList<>();

        for(var key : methods.keySet()) {
            for(var method : methods.get(key)) {
                if(isMethodInvalid(method)) {
                    isInvalid = true;
                    invalidMethods.add(method);
                }
            }
        }

        return isInvalid;
    }

    @Override
    public String getErrorType() {
        if(!isInvalid)
            return "ok";

        return "Error";
    }

    abstract public String getMessage();
}

